package cokr.xit.ens.modules.kkomydoc.domain.repository;

import cokr.xit.ens.core.utils.CmmnUtil;
import cokr.xit.ens.modules.common.ctgy.sys.mng.model.TmpltMngSearchDTO;
import cokr.xit.ens.modules.kkomydoc.domain.TmpltMngKkoMydoc;
import cokr.xit.ens.modules.kkomydoc.model.TmpltMngKkoMydocDTO;
import com.querydsl.core.BooleanBuilder;
import com.querydsl.core.types.Projections;
import com.querydsl.core.types.QBean;
import com.querydsl.jpa.impl.JPAQueryFactory;
import lombok.RequiredArgsConstructor;

import java.util.List;
import java.util.Optional;

import static cokr.xit.ens.modules.common.ctgy.sys.mng.domain.QOrgMng.orgMng;
import static cokr.xit.ens.modules.kkomydoc.domain.QTmpltMngKkoMydoc.tmpltMngKkoMydoc;

@RequiredArgsConstructor
public class TmpltMngKkoMydocRepositoryImpl implements TmpltMngKkoMydocRepositoryCustom {

    private final JPAQueryFactory query;

    @Override
    public Optional<TmpltMngKkoMydoc> findFetchByOrgCdAndTmpltCd(String orgCd, String tmpltCd) {
        return Optional.ofNullable(query.selectFrom(tmpltMngKkoMydoc)
                .where(tmpltMngKkoMydoc.orgMng.orgCd.eq(orgCd)
                        .and(tmpltMngKkoMydoc.tmpltCd.eq(tmpltCd)))
                .fetchOne());
    }

    @Override
    public List<TmpltMngKkoMydoc> findAllFetchBySearchDTO(TmpltMngSearchDTO searchDTO) {
        return query.selectFrom(tmpltMngKkoMydoc)
                .innerJoin(tmpltMngKkoMydoc.orgMng, orgMng)
                .fetchJoin()
                .where(eqSearchDTO(searchDTO))
                .fetch();
    }

    @Override
    public Optional<TmpltMngKkoMydocDTO> findDtoByOrgCdAndTmpltCd(String orgCd, String tmpltCd) {
        return Optional.ofNullable(query.select(mappedDto())
                .from(tmpltMngKkoMydoc)
                .where(tmpltMngKkoMydoc.orgMng.orgCd.eq(orgCd)
                        .and(tmpltMngKkoMydoc.tmpltCd.eq(tmpltCd)))
                .fetchOne());
    }


    @Override
    public List<TmpltMngKkoMydocDTO> findAllDtoBySearchDTO(TmpltMngSearchDTO searchDTO) {
        return query.select(mappedDto())
                .from(tmpltMngKkoMydoc)
                .innerJoin(tmpltMngKkoMydoc.orgMng, orgMng)
                .where(eqSearchDTO(searchDTO))
                .fetch();
    }

    private QBean<TmpltMngKkoMydocDTO> mappedDto() {
        return Projections.fields(TmpltMngKkoMydocDTO.class
                , tmpltMngKkoMydoc.dtype
                , tmpltMngKkoMydoc.orgMng.orgCd
                , tmpltMngKkoMydoc.orgMng.orgNm
                , tmpltMngKkoMydoc.tmpltCd
                , tmpltMngKkoMydoc.title
                , tmpltMngKkoMydoc.message
                , tmpltMngKkoMydoc.useYn

                , tmpltMngKkoMydoc.csNumber
                , tmpltMngKkoMydoc.csName
                , tmpltMngKkoMydoc.ciTransUseYn
                , tmpltMngKkoMydoc.tmpltMsgUseYn
                , tmpltMngKkoMydoc.tmpltCsInfoUseYn
                , tmpltMngKkoMydoc.pryMessage
        );
    }

    @Override
    public Optional<TmpltMngKkoMydoc> findFetchByOrgCdAndTmpltCdAndUseYn(String orgCd, String tmpltCd, String useYn) {
        return Optional.ofNullable(
                query.selectFrom(tmpltMngKkoMydoc)
                        .innerJoin(tmpltMngKkoMydoc.orgMng, orgMng)
                        .fetchJoin()
                        .where(
                                tmpltMngKkoMydoc.orgMng.orgCd.eq(orgCd)
                                        .and(tmpltMngKkoMydoc.tmpltCd.eq(tmpltCd))
                                        .and(tmpltMngKkoMydoc.useYn.eq(useYn))
                        )
                        .fetchOne());
    }

    private BooleanBuilder eqSearchDTO(TmpltMngSearchDTO searchDTO) {
        BooleanBuilder builder = new BooleanBuilder();

        if (!CmmnUtil.isEmpty(searchDTO.getSchOrgCd()))
            builder.and(tmpltMngKkoMydoc.orgMng.orgCd.eq(searchDTO.getSchOrgCd()));

        if (!CmmnUtil.isEmpty(searchDTO.getSchTmpltCd()))
            builder.and(tmpltMngKkoMydoc.tmpltCd.eq(searchDTO.getSchTmpltCd()));

        if (!CmmnUtil.isEmpty(searchDTO.getSchTitle()))
            builder.and(tmpltMngKkoMydoc.title.like(searchDTO.getSchTitle() + "%"));


        return builder;
    }

}
